.model tiny
.386p
.code
org 256
s:
mov ax,13h
int 10h              ;320x200x256

mov dx,14+23*256     ;BUBBLE FIGHT
mov cx,offset txt1
call txt

mov ax,0a000h
mov ds,ax

mov di,320*168
xxy:
mov cx,320
yyx:
cmp byte ptr [di],0
jne wxy
mov [di],al          ;Col.Bars
wxy:
inc di
loop yyx
add al,4
jnz xxy


mov es,cx            ;Key-Int
mov ax,cs
shl eax,16
mov ax,offset keyint
mov ebx,es:[36]          ;GetIntVec
mov es:[36],eax          ;SetIntvec
mov dword ptr cs:x,ebx


mov eax,160+100*65536
mov dword ptr cs:x[8],eax   ;x / y
mov ah,2
mov word ptr cs:x[6],ax
cld
push cs
pop  es
mov di,offset x+50
mov cl,128           ;Clear Key-Tab
rep stosb

mov di,offset x+500
mov cl,100
tab:
add ax,41571         ;Random Tab for Bubbles
stosw
loop tab

xor bx,bx
mov si,63
t:
mov ax,bx
mul al
shr ax,6
mov cs:x[200+bx],al
mov cs:x[392+si],al
mov cl,127
sub cl,al            ;Sinus-Ersatz; ab x+200 bis x+455
mov cs:x[264+si],cl
mov cs:x[328+bx],cl
dec si
inc bx
cmp bx,64
jne t

mov bp,256
col:
mov ax,bp
mov dx,3c8h
out dx,al
inc dx
xor cx,cx            ;Colors
call RGB
inc cl
call RGB
inc cl
call RGB
dec bp
jnz col



mov di,offset x+1000
mov bx,128
yy:
mov si,128
xx:
mov al,cs:x[bx+262]  ;Kugel-Sprite
add al,cs:x[si+262]
cmp al,200
ja ww
xor al,al
jz ww2
ww:
add al,20
add al,bl
add ax,si
shr al,2
ww2:
stosb
sub si,4
jnz xx
sub bl,4
jnz yy



push es
pop ds
mov bh,80h
mov es,bx

xor di,di
mov bp,200
mov si,offset x+200
yyy:
mov cx,320
mov ax,bp
dec ax
xchg al,ah
mov dx,200
div dl
xor dh,dh
mov dl,al
xxx:                 ;Plasma
mov bx,dx
mov al,[bx+si]
add bx,cx
shl bl,1
xor bh,bh
add al,[bx+si]
shr al,1
mov bx,cx
xor bh,bh
add al,[bx+si]
shr al,2
stosb
loop xxx
dec bp
jnz  yyy





call ClrSc           ;ClrScr
mov dx,15+10*256
mov cx,offset txt2
call txt             ;GET READY !

kkk:
in al,60h
and al,128           ;WaitKey
jnz kkk



key:
push cs
pop ds
mov di,offset x+4

mov si,[di]          ;Scroll
mov bx,si
inc si
xor bx,si
mov [di],si
inc di
inc di
mov al,[di]
test bl,12
jz wt
dec al               ;Calculate Ofs
jnz wt
mov al,200
wt:
mov [di],al


mov bl,160
mul bl
shl ax,1
mov si,ax
push si
mov cx,64000
sub cx,si
shr cx,2

mov ax,8000h         ;Copy from $80000 to $70000
mov ds,ax
mov ax,7000h
mov es,ax

xor di,di
rep movsd
xor si,si
pop cx
shr cx,2
rep movsd

mov cx,word ptr cs:x[8]
mov al,cs:x[10]
xor bl,bl

cmp cx,320-32
je w1
cmp bl,cs:x[50+77]
jnz w1
inc cx
w1:
                     ;X,Y-Koordinaten
or cx,cx
jz w2
cmp bl,cs:x[50+75]
jnz w2
dec cx
w2:
                     ;Scan-Codes:77=+x,72=-y,80=+y,75=-x
or al,al
jz w3
cmp bl,cs:x[50+72]
jnz w3
dec al
w3:

cmp al,200-32-32
je w4
cmp bl,cs:x[50+80]
jnz w4
inc al
w4:



mov word ptr cs:x[8],cx
mov cs:x[10],al

mov bl,160
mul bl
shl ax,1
mov di,ax            ;Your Ball
add di,cx
xor bp,bp
call sprite

xor bh,bh
mov bl,cs:x[7]

add word ptr cs:x[502+bx],63
cmp cs:x[503+bx],214
jne ball
add cs:x[7],2

ball:
mov bp,128

mov di,word ptr cs:x[500+bx]
test cs:x[4],1
jz wy
add di,320
wy:
mov cx,di            ;Enemy Balls
cmp ch,214
jne wx
add cl,cs:x[498+bx]
wx:
mov word ptr cs:x[500+bx],cx

mov si,di
shr si,6
and si,255
mov ax,word ptr cs:x[199+si]
shr ax,11
add di,ax

mov ax,di
mov cx,320
xor dx,dx
div cx
sub al,cs:x[10]
add al,32-8
cmp al,64-16
ja nocoll            ;Kollision ?

sub dx,word ptr cs:x[8]
add dx,32-8
cmp dx,64-16
ja nocoll


call ClrSc

mov dx,16+10*256
mov cx,offset txt3
call txt
kky:
in al,60h
cmp al,1
jnz kky
                     ;GAME OVER
jmp ende

nocoll:


call sprite


dec bx
dec bx
jnz ball

mov dx,3dah
retr:
in al,dx
and al,8             ;Wait Retrace
jz retr

push es
pop ds
mov ax,0a000h
mov es,ax            ;Point Line
mov al,ah
mov di,word ptr cs:x[6]
shr di,8
shl di,1
add di,170*320
stosw
stosw

mov cx,16000-80*32
xor di,di            ;Copy from $70000 to $A0000
xor si,si
rep movsd

in al,60h
cmp al,1             ;ESC
jne key
ende:
xor ax,ax
mov es,ax
mov ebx,dword ptr cs:x
mov es:[36],ebx             ;SetIntvec

mov al,3                    ;Textmode
int 10h

mov ah,4ch                  ;End
int 21h

keyint:
push ax
push bx                     ;Key
in al,60h
mov bx,ax
and bx,127
and al,128
mov cs:x[50+bx],al
mov al,20h
out 20h,al
pop bx
pop ax
iret

Sprite:                     ;DI = Start Addr
                            ;BP = Color
push ds
push cs
pop ds
mov si,offset x+1000
mov cl,32
y1:
mov ch,32
x1:
lodsb
or al,al
jz np
add ax,bp
stosb
dec di
np:
inc di
dec ch
jnz x1
add di,320-32
dec cl
jnz y1
pop ds
ret

RGB:
mov bx,bp
shl bx,cl                   ;Set Color
xor bh,bh
mov al,cs:x[200+bx]
shr al,1
out dx,al
ret

TXT:
push ds
xor bx,bx
mov ah,2
int 10h
mov dx,cx
push cs
pop ds
mov ah,9
int 21h                     ;Write Text
mov bx,0a000h
mov ds,bx
add bh,90
sub ah,2
i:
cmp [bx],ah
jne www
mov al,bh
shl al,1
add [bx],al
www:
dec bx
jnz i
pop ds
ret

ClrSc:
mov ax,0a000h
mov es,ax
xor di,di                   ;ClrScr
xor ax,ax
mov cx,32000-160*32
rep stosw
ret

txt1 db 'BUBBLE FIGHT$'
txt2 db 'GET READY !$'
txt3 db 'GAME OVER$'

x    db 0
end s